#ifndef ASYM_BOX_GRAPH_H
#define ASYM_BOX_GRAPH_H
#include "Box.h"
#include "Grid.h"
#include <vector>
namespace Asym{
//BoxGraphڼbox֮Ķϵγһgraph
	struct BoxGraphNode{
	int nodeId;
	int boxId;
	int left;
	int right;
	int bottom;
	int top;

	int row;
	int col;
	BoxGraphNode(int i,int n):nodeId(n),boxId(i),left(-1),right(-1),bottom(-1),top(-1),row(0),col(0){}
};


class BoxGraph{
	BoxSet &_boxSet;
	std::vector<BoxGraphNode> nodes;
	std::vector<int> rowHead;

	Box& boxOfNode(int nodeId);
	int newNode(int boxId);
	void insertIntoRow(int boxId,int row);

	int findNodeAlignedTo(int row, int nodeId);
void updateGraphTopology();
	void addBox(int boxId);
	int nodeDistance(int nodeA,int nodeB, int dim);
	std::vector<int> findGridStartFrom(int i,int dx,int dy,int xthreshold,int ythreshold);
	Grid createGridFrom(std::vector<int> &nodeIndices,int dx,int dy);
	void reset();
public:
	//boxsetڹ캯ָ
	BoxGraph(BoxSet& bset);

	//ȡеgridγgraphĹڸúڲ
	//boxIndicesΪboxsetboxţgrids洢
	//xthresholdжxǷһֵ
	//Ϊνbox롱ЩλҪboxϸ룬Ļboxsetͺʹ
	void extractGrids(std::vector<int>& boxIndices,std::vector<Grid>& out_grids,float xthreshold,float ythreshold);

	void print();
	void saveSvg(std::string fn,std::vector<int>& boxIndices);
};

}
#endif